
__kernel void computeDensityFluctuation
(
  __global float* pressure, 
  __global float* densityPrediction, 
  __global float* a_ii,  
  __global float* sumA, 
  __global float* densityFluctuation
) 
{
  int i = get_global_id(0);
  
  float a_iii = a_ii[i];
  
  if (fabs(a_iii) > 1e-10) {
    float pressurei = pressure[i];
    float sumAi = sumA[i];
    float densityPredictioni = densityPrediction[i];
    
	  densityFluctuation[i] = max((float)(pressurei * a_iii + sumAi + densityPredictioni - density0), (float)0.0);
		pressure[i] = max(((float)(1 - omega) * pressurei + omega * (density0 - densityPredictioni - sumAi) / a_iii), (float)0.0);
  }
  else {
    densityFluctuation[i] = density0;
	  pressure[i] = 0;
  }
}
