
__kernel void normalizeDensitySecondPass
(
  __global float* density, 
  __global float* isoDensity,
  __global float* densityFluctuation,
  __global float* pressure,
  const int computePressure
) 
{
  int i = get_global_id(0);

  float isoDensityTmp = isoDensity[i];
  float densityTmp = density[i];
  
  // DENSITY
  isoDensityTmp = (wDensity * (isoDensityTmp + mass0 / densityTmp));
  densityTmp = densityTmp / isoDensityTmp;
  densityFluctuation[i] = densityTmp - density0;
  
  if (computePressure) {
    float pressureComp = seventh * density0 * stiffness * (pow(densityTmp / density0, 7) - 1);
    if (pressureComp < 0) {
      pressureComp *= negativePressureFactor;
    }
    pressure[i] = pressureComp; 
  }
  
  // Final sum
  isoDensity[i] = isoDensityTmp;
  density[i] = densityTmp;
}
