
__kernel void integrateIisph
(
  __global float3* pos, 
  __global float3* vel, 
  __global float3* acc,
  __global float3* pressureForce,
  __global float3* velocityPrediction,
  const int useVortex
)
{
  int i = get_global_id(0);
  
  if (useVortex) {
	  float3 d = pos[i] - vortexOrigin;
		float d2 = length2v(d);
		float ad = dot(vortexAxis, vortexOrigin);
		float r = sqrt(d2 - ad*ad);
		float3 a = (vortexFactor / (r * (r + 0.1))) * cross(vortexAxis, d);
    
		acc[i] += a;
	}
  
  vel[i] = velocityPrediction[i] + (deltaTime * acc[i]) + (deltaTime * pressureForce[i]);
}
