
__kernel void integrateVelocities
(
  __global float3* pos,
  __global float3* vel, 
  __global float3* acc, 
  __global float3* pressureForce,
  const int useVortex
)
{
  int i = get_global_id(0);
  
  float3 acci = acc[i];
  
  if (useVortex) {
	  float3 d = pos[i] - vortexOrigin;
		float d2 = length2v(d);
		float ad = dot(vortexAxis, vortexOrigin);
		float r = sqrt(d2 - ad*ad);
		float3 a = (vortexFactor / (r * (r + 0.1))) * cross(vortexAxis, d);
    
		acci += a;
	}
  
  acci += pressureForce[i];
  
  float a2 = length2v(acci);
	if (a2 > accelerationLimit2) {
    float accelerationLimitFactor = accelerationLimit / sqrt(a2);
    acci *= accelerationLimitFactor;
  }
  
  vel[i] += deltaTime * acci;
}
