
__kernel void computeNeighboursFluidCount
(
  __global float3* pos,  
  __global ulong2* gridCellsFluid,
  __global int* gridCellIndicesFluid,
  __global ulong* lastCellFluid,
  __global int* neighboursFluidFluidCount,
  __global float3* solidPos, 
  __global ulong2* gridCellsSolid,
  __global int* gridCellIndicesSolid,
  __global ulong* lastCellSolid,
  __global int* neighboursFluidSolidCount
)
{
  int i = get_global_id(0);

  float3 posi = pos[i];
  
  int posXic = posi.x * invRadius;
  int posYic = posi.y * invRadius;
  int posZic = posi.z * invRadius;
  
  int kf = 0, ks = 0;
  int x, y, z, j, jj;
  ulong zOrderPos;
  
  ulong lastCellSolid0 = lastCellSolid[0];
  ulong lastCellFluid0 = lastCellFluid[0];
  
  for (x = -1; x <= 1; x++) {
    for (y = -1; y <= 1; y++) {
      for (z = -1; z <= 1; z++) {
        zOrderPos = zOrder(posXic + x, posYic + y, posZic + z); 
        
        if (zOrderPos <= lastCellFluid0) {
          for (j = gridCellIndicesFluid[zOrderPos], jj = gridCellsFluid[j].y; gridCellsFluid[j].x == zOrderPos; j++, jj++) {
            if (jj != i) {
              if (distance2(posi.x, posi.y, posi.z, pos[jj].x, pos[jj].y, pos[jj].z) < radius2) {
                kf++;
              }
            }
          }
        }
        
        if (zOrderPos <= lastCellSolid0) {
          for (j = gridCellIndicesSolid[zOrderPos], jj = gridCellsSolid[j].y; gridCellsSolid[j].x == zOrderPos; j++, jj++) {
            if (jj != i) {
              if (distance2(posi.x, posi.y, posi.z, solidPos[jj].x, solidPos[jj].y, solidPos[jj].z) < radius2) {
                ks++;
              }
            }
          }
        }
      }
    }
  }

  neighboursFluidFluidCount[i] = kf;
  neighboursFluidSolidCount[i] = ks;
}
