
__kernel void findNeighboursFluidN2
(
  __global float3* pos,
  __global int* neighboursFluidFluid,
  __global int* neighboursFluidFluidCount,
  const int neighboursFluidFluidCountMax,
  __global float3* solidPos, 
  __global int* neighboursFluidSolid,
  __global int* neighboursFluidSolidCount,
  const int neighboursFluidSolidCountMax  
) 
{
  int i = get_global_id(0);
  int offsetFluid = i*neighboursFluidFluidCountMax;
  int offsetSolid = i*neighboursFluidSolidCountMax;
  
  float3 posi = pos[i];
  
  int k = 0;
  
  for (int j = 0; j < fluidParticlesCount; j++) {
    if (j != i && k < neighboursFluidFluidCountMax) {
      if (distance2(posi.x, posi.y, posi.z, pos[j].x, pos[j].y, pos[j].z) < radius2) {
        neighboursFluidFluid[offsetFluid + k] = j;
        k++;
      }
    }
  } 
  
  if (k < neighboursFluidFluidCountMax) {
    neighboursFluidFluid[offsetFluid + k] = -1;
  }
  neighboursFluidFluidCount[i] = k;
  
  k = 0;
  
  for (int j = 0; j < solidParticlesCount; j++) {
    if (j != i && k < neighboursFluidSolidCountMax) {
      if (distance2(posi.x, posi.y, posi.z, solidPos[j].x, solidPos[j].y, solidPos[j].z) < radius2) {
        neighboursFluidSolid[offsetSolid + k] = j;
        k++;
      }
    }
  } 
  
  if (k < neighboursFluidSolidCountMax) {
    neighboursFluidSolid[offsetSolid + k] = -1;
  }
  neighboursFluidSolidCount[i] = k;
}
