
__kernel void mergeSortMerge
(
  __global const ulong2* in,
  __global ulong2* out,
  const int mergeSize,
  const int totalSize,
  __global ulong* lastCell
)
{
  int id = get_global_id(0);
  int first = id * (mergeSize << 1);
  int second = first + mergeSize;

  int firstEnd = second;
  int secondEnd = ((second + mergeSize > totalSize) ? totalSize : second + mergeSize);
  
  int i = 0;
  if (firstEnd >= totalSize) {
    for (i = first; i < totalSize; i++) {
      out[i] = in[i];
    }
  }
  else {
    for (i = first; i < secondEnd; i++) {
      if (in[first].x < in[second].x) {
        out[i] = in[first];
        first++;
        if (first >= firstEnd) {
          i++;
          break;
        }
      }
      else {
        out[i] = in[second];
        second++;
        if (second >= secondEnd) {
          i++;
          break;
        }
      }
    }
    
    if (first >= firstEnd) {
      for ( ; i < secondEnd; i++) {
        out[i] = in[second];
        second++;
      }
    }
    else if (second >= secondEnd) {
      for ( ; i < secondEnd; i++) {
        out[i] = in[first];
        first++;
        
      }
    }
    
    if (i-1 == totalSize-1) {
      lastCell[0] = out[i-1].x;
    }
  }
}
