#include "clframework.h"

using namespace clframework;

CLFunction::CLFunction(std::string sourcePath, std::string name) :
  name(name) {

  this->source = loadFunction(sourcePath);
}

CLFunction::~CLFunction() {

}

std::string CLFunction::loadFunction(std::string sourcePath) {
  std::ifstream functionFile(sourcePath);
  std::ostringstream ss;

  if (functionFile.is_open()) {
    std::string line;

    while (functionFile.good()) {
      getline(functionFile, line);
      ss << line << std::endl;
    }

    functionFile.close();

    Log::getInstance()->writeLine(CLDebug, "Loading OpenCL function file \'" + sourcePath + "\' successfull");
  }
  else {
    Log::getInstance()->writeLine(CLError, "Could not load OpenCL function file \'" + sourcePath + "\'");
  }

  return ss.str();
}