#include <CL/cl.h>

namespace clframework {

  class CLSystem;
  class CLDevice;
  class CLProgram;

  class CLKernelArgument: public CLVariable {

    protected:

      virtual bool allocate();
      virtual void release();

      virtual bool setAsArgument(CLProgram* program, unsigned int argID, unsigned int deviceID = 0, size_t kernelLocalSize = 0);
      virtual size_t getElementCount(unsigned int deviceID) { return 0; }

    public:
      
      CLKernelArgument(std::string name, CLVariableDataType varDataType, unsigned int elements = 1, bool paralelize = false);
      virtual ~CLKernelArgument();

  };

}