#include <CL/cl.h>

namespace clframework {

  class CLDevice;
  class CLPlatform;

  class CLLink {

    private:

      friend class CLProgram;

      cl_context context;

      std::vector<CLDevice*> devices;
      std::vector<cl_command_queue> queues;

      bool initialize(std::vector<CLDevice*>& devices);
      bool buildProgram(cl_program program, const std::string& buildOptions);

      bool finish();

    public:

      CLLink(std::vector<CLDevice*>& devices);
      CLLink(CLDevice* device);
      CLLink(CLPlatform* platform);
      ~CLLink();

      cl_uint getDeviceCount() { return devices.size(); };
      CLDevice* getDevice(unsigned int i) { return devices[i]; }
      const cl_command_queue& getQueue(unsigned int i) { return queues[i]; }
      unsigned int getMinMaxWorgroupSize();

      const cl_context& getContext() { return context; }
      CLPlatform* getPlatform();

  };

}