#include <CL/cl.h>

namespace clframework {

  class CLPlatform {

    private:

      cl_platform_id id;
      std::string name;
      std::string vendor;
      std::string clVersion;

      std::vector<CLDevice*> devices;

    public:

      CLPlatform(cl_platform_id id);
      ~CLPlatform();

      void initialize();

      cl_platform_id getId() { return id; };
      const std::string& getName() { return name; };
      const std::string& getVendor() { return vendor; };
      const std::string& getClVersion() { return clVersion; };

      cl_uint getDeviceCount() { return devices.size(); };
      CLDevice* getDevice(unsigned int i) { return devices[i]; }
      std::vector<CLDevice*> getDevices(cl_device_type type = CL_DEVICE_TYPE_ALL);

  };

}