
__kernel void computeD_ijp_j
(
  __global float3* pos, 
  __global float3* d_ijp_j, 
  __global float* density, 
  __global float* pressure, 
  __global int* neighboursFluidFluid,
  const int neighboursFluidFluidCountMax
) 
{
  int i = get_global_id(0);
  int fluidStart = i*neighboursFluidFluidCountMax;
  int fluidEnd = fluidStart + neighboursFluidFluidCountMax;
  
  float3 posi = pos[i];
  
  int j;
  
  float r, t, tp, dterm;
  float3 vec;
  
  float3 d_ijp_jTmp = d_ijp_j[i];
  
  // Fluid-fluid loop
  for (int k = fluidStart; k < fluidEnd; k++) {
    j = neighboursFluidFluid[k];
    
    if (j > -1) {
      vec = posi - pos[j];
    
      r = length(vec); 
			t = 1 - r * invRadius;

      tp = dWPressure * t * t / r;
      dterm = mass0 / (density[j] * density[j]) * pressure[j] * tp;
      
		  d_ijp_jTmp -= dterm * vec;
    }
    else {
      break;
    }
  }
  
  d_ijp_jTmp *= deltaTime2;
  
  // Final sum
  d_ijp_j[i] = d_ijp_jTmp;
}
