
__kernel void computeSolidVolume
(
  __global float3* solidPos,
  __global float* solidVolume, 
  __global int* neighboursSolidSolid,
  const int neighboursSolidSolidCountMax
) 
{
  int i = get_global_id(0);
  int solidStart = i*neighboursSolidSolidCountMax;
  int solidEnd = solidStart + neighboursSolidSolidCountMax;
  
  float3 solidPosi = solidPos[i];
  
  int j;
  
  float r2, t, t2, t3;
  float3 vec;
  
  float solidVolumeTmp = 0;
  
  // Solid-solid loop
  for (int k = solidStart; k < solidEnd; k++) {
    j = neighboursSolidSolid[k];
		
    if (j > -1) {
      vec = solidPosi - solidPos[j];
      
      r2 = length2v(vec); 
      
      t = 1 - r2 * invRadius2;
      t2 = t*t;
      t3 = t2*t;
      
      solidVolumeTmp += t3;
    }
    else {
      break;
    }
  }
    
  solidVolumeTmp += 1;
  solidVolumeTmp *= wDensity;
  solidVolumeTmp = density0 / solidVolumeTmp; 

  // Final sum
  solidVolume[i] = solidVolumeTmp;  
}
