
__kernel void integrateVelocitiesWCSPH
(
  __global float3* pos, 
  __global float3* vel,
  __global float3* acc,
  const int useVortex
)
{
  int i = get_global_id(0);
  
  float3 accTmp = acc[i];
  
  if (useVortex) {
	  float3 d = pos[i] - vortexOrigin;
		float d2 = length2v(d);
		float ad = dot(vortexAxis, vortexOrigin);
		float r = sqrt(d2 - ad*ad);
		float3 a = (float)(vortexFactor / (r * (r + 0.1f))) * cross(vortexAxis, d);
    
		accTmp += a;
	}
  
  float a2 = length2v(accTmp);
	if (a2 > accelerationLimit2) {
    float accelerationLimitFactor = accelerationLimit / sqrt(a2);
    accTmp *= accelerationLimitFactor;
  }
  
  vel[i] += deltaTime * accTmp;
}
