
__kernel void computeNeighboursSolidCount
(
  __global float3* solidPos,
  __global ulong2* gridCellsSolid,
  __global int* gridCellIndicesSolid,
  __global ulong* lastCellSolid,
  __global int* neighboursSolidSolidCount
)
{
  int i = get_global_id(0);

  float3 solidPosi = solidPos[i];
  
  int solidPosXic = solidPosi.x * invRadius;
  int solidPosYic = solidPosi.y * invRadius;
  int solidPosZic = solidPosi.z * invRadius;
  
  int ks = 0;
  int x, y, z, j, jj;
  ulong zOrderPos;
  
  ulong lastCellSolid0 = lastCellSolid[0]; 
  
  for (x = -1; x <= 1; x++) {
    for (y = -1; y <= 1; y++) {
      for (z = -1; z <= 1; z++) {
        zOrderPos = zOrder(solidPosXic + x, solidPosYic + y, solidPosZic + z); 

        if (zOrderPos <= lastCellSolid0) {
          for (j = gridCellIndicesSolid[zOrderPos], jj = gridCellsSolid[j].y; gridCellsSolid[j].x == zOrderPos; j++, jj++) {
            if (jj != i) {
              if (distance2(solidPosi.x, solidPosi.y, solidPosi.z, solidPos[jj].x, solidPos[jj].y, solidPos[jj].z) < radius2) {
                ks++;
              }
            }
          }
        }
      }
    }
  }

  neighboursSolidSolidCount[i] = ks;
}
