
__kernel void createCells
(
  __global float3* pos, 
  __global ulong2* gridCells
)
{
  int i = get_global_id(0);
  
  float3 posiInv = pos[i] * invRadius;
  
  if (posiInv.x >= 0 && posiInv.y >= 0 && posiInv.z >= 0) {
    gridCells[i].x = zOrder(posiInv.x, posiInv.y, posiInv.z);
  }
  else {
    gridCells[i].x = 0;
  }
  
  gridCells[i].y = i;
}
