#include "../main.h"

Light::Light(glm::vec4& ambient, glm::vec4& diffuse, glm::vec4& specular, glm::vec4& position):
  enabled(false),
  ambient(ambient),
  diffuse(diffuse),
  specular(specular),
  position(position) {

  quadric = gluNewQuadric();
}

Light::~Light() {

}

GLvoid Light::enableLight() {
  enabled = true;
}

GLvoid Light::disableLight() {
  enabled = false;
}

GLvoid Light::renderLight(Camera* camera) {
  glPushMatrix();

  glTranslatef(position.x, position.y, position.z);
  OpenGL::applyBillboard(camera, glm::vec3(position));

  GLfloat distance = glm::distance(camera->getPosition(), glm::vec3(position));

  glColor3f(1.0f, 1.0f, 1.0f);
  glDisable(GL_CULL_FACE);
  gluDisk(quadric, 0.0f, 0.005f * distance, 32, 1);

  glPopMatrix();
}