#pragma once

class Light {

  protected:

    GLboolean enabled;

    glm::vec4 ambient;
    glm::vec4 diffuse;
    glm::vec4 specular;
    glm::vec4 position;

    glm::mat4 viewLightMatrix;
    glm::mat4 viewCameraMatrix;
    glm::mat4 projLightMatrix;

    GLUquadricObj* quadric; 

  public:

    Light(glm::vec4& ambient, glm::vec4& diffuse, glm::vec4& specular, glm::vec4& position);
    ~Light();

    GLvoid enableLight();
    GLvoid disableLight();

    GLboolean isEnabled()                                                                                   { return enabled; };

    GLfloat& operator[](GLint i)                                                                            { return position[i]; };

    glm::vec4 getAmbient()                                                                                  { return ambient; };
    glm::vec4 getDiffuse()                                                                                  { return diffuse; };
    glm::vec4 getSpecular()                                                                                 { return specular; };
    glm::vec4 getPosition()                                                                                 { return position; };

    GLvoid renderLight(Camera* camera);

};