#pragma once

class OpenGL;
class Window;

class LightsManager {

  private:

    std::vector<Light*> lights;

    GLint numEnabledLights();

  public:

    LightsManager();
    ~LightsManager();

    GLboolean initLights();
    GLvoid freeLights();

    Light* getLight(GLint index)                                                                            { return lights[index]; };
    GLint numLights()                                                                                       { return lights.size(); };

    GLvoid updateEnabledLights();

    GLvoid applyEnabledLights(Camera* camera);
    GLvoid cancelEnabledLights();
    
    GLvoid renderEnabledLights(Camera* camera);

    GLvoid keyDown(GLint key);
    GLvoid keyUp(GLint key);

    GLvoid mouseDown(GLint mouseButton, GLint x, GLint y);
    GLvoid mouseUp(GLint mouseButton, GLint x, GLint y);
    GLvoid mouseMove(GLint mouseButton, GLint x, GLint y);
    GLvoid mouseScroll(GLfloat delta);

};