#pragma once

class Material {

  private:

    glm::vec4 ambient;
    glm::vec4 diffuse;
    glm::vec4 specular;
    glm::vec4 emission;

    GLfloat shininess;

	  GLenum polygonMode;
    GLboolean faceCulling;

    GLvoid deleteMaterial();

  public:

    Material();
    ~Material();

    GLboolean loadMaterial(glm::vec4 ambient, glm::vec4 diffuse, glm::vec4 specular, glm::vec4 emission, GLfloat shininess, GLenum polygonMode, GLboolean faceCulling);

    GLvoid applyMaterial();
    GLvoid applyMode();
    GLvoid cancelMaterial();

    GLvoid setAmbient(float r, float g, float b, float a)                                                   { ambient.r = r; ambient.g = g; ambient.b = b; ambient.a = a; };
    GLvoid setDiffuse(float r, float g, float b, float a)                                                   { diffuse.r = r; diffuse.g = g; diffuse.b = b; diffuse.a = a; };
    GLvoid setSpecular(float r, float g, float b, float a)                                                  { specular.r = r; specular.g = g; specular.b = b; specular.a = a; };
    GLvoid setEmission(float r, float g, float b, float a)                                                  { emission.r = r; emission.g = g; emission.b = b; emission.a = a; };

    GLboolean getFaceCulling()                                                                              { return faceCulling; };
    GLvoid setFaceCulling(GLboolean faceCulling)                                                            { this->faceCulling = faceCulling; };

};