#pragma once

class ShadersManager {

  private:

    std::map<std::string, GLhandleARB> vertexShaders;
    std::map<std::string, GLhandleARB> fragmentShaders;
    std::map<std::string, GLhandleARB> programs;

    const char* loadTextFile(const char* fname);
    void printInfoLog(std::string programName, const GLhandleARB obj);
    GLhandleARB getShader(std::string programName, const char* fname, const GLenum shaderType);

  public:

    ShadersManager();

    bool createProgram(std::string programName, std::string vertexShader, std::string fragmentShader);
    bool deleteProgram(std::string programName);
    GLhandleARB getProgram(std::string programName);

    bool createShaders();
    void deleteShaders();

};