#pragma once

#include <string>
#include <iostream>
#include <sstream>
#include <fstream>
#include <set>

enum LogType {
  CLDebug,
  CLError,
  CLInfo,
  GLDebug,
  GLError,
  GLInfo,
  WndDebug,
  WndError,
  WndInfo,
  SPHDebug,
  SPHError,
  SPHInfo,
  Custom
};

class Log {

  private:

    static Log* logInstance;

    const std::string fileName;
    std::ofstream file;

    std::set<LogType> supress;

    bool newLine;

    Log();
    ~Log();

    static std::string logTypeString(LogType type);
    static std::string deleteNullChars(std::string str);

    void writeLog(LogType type, const std::string& str);

  public:

    void write(LogType type, const std::string& str);
    void writeLine(LogType type, const std::string& str);

    void write(const std::string& str);
    void writeLine(const std::string& str);

    void supressLogType(LogType type);

    static Log* getInstance();

};