#include "main.h"

namespace {
  Window window;
}

LRESULT CALLBACK WndProc(HWND	hWnd,	UINT uMsg, WPARAM wParam, LPARAM lParam) {
	switch (uMsg) {

		case WM_ACTIVATE: {
      if (!HIWORD(wParam)) {
        window.setActive(true);
			}
			else {
				window.setActive(false);
			}
			return 0;						
		}

    case WM_KILLFOCUS: {
      //window.setActive(false);
      return 0;
    }

    case WM_SETFOCUS: {
      //window.setActive(true);
      return 0;
    }

		case WM_SYSCOMMAND: {

			break;							
		}

		case WM_CLOSE: {
			PostQuitMessage(0);				
			return 0;						
		}

    case WM_KEYDOWN: {
      window.keyDown(wParam);			
			return 0;						
		}

		case WM_KEYUP: {
      window.keyUp(wParam);		
			return 0;			
		}

    case WM_LBUTTONDOWN: {
      window.mouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam));
      return 0;
    }

    case WM_LBUTTONUP: {
      window.mouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam));
      return 0;
    }

    case WM_RBUTTONDOWN: {
      window.mouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam));
      return 0;
    }

    case WM_RBUTTONUP: {
      window.mouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam));
      return 0;
    }

    case WM_MBUTTONDOWN: {
      window.mouseDown(MK_MBUTTON, LOWORD(lParam), HIWORD(lParam));
      return 0;
    }

    case WM_MBUTTONUP: {
      window.mouseUp(MK_MBUTTON, LOWORD(lParam), HIWORD(lParam));
      return 0;
    }

    case WM_MOUSEMOVE: {
      window.mouseMove(wParam, LOWORD(lParam), HIWORD(lParam));
      return 0;
    }

    case WM_MOUSEWHEEL: {
      window.mouseScroll(-GET_WHEEL_DELTA_WPARAM(wParam));
      return 0;
    }

		case WM_SIZE: {
      if (window.isWindowCreated() && window.isSizeable()) {
        if (wParam == SIZE_MAXIMIZED) {
          Settings::getInstance().setMaximized(true);
        }
        else {
          Settings::getInstance().setMaximized(false);
        }
        Settings::getInstance().setWidth(LOWORD(lParam));
        Settings::getInstance().setHeight(HIWORD(lParam));
			  window.updateWindowSize();
      }
			return 0;								
		}

	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

int main() {  
  MSG	msg;									
	BOOL done = false;	

  char appPath[MAX_PATH];
  GetCurrentDirectory(MAX_PATH, appPath);

  std::ostringstream ss;
  ss << appPath << "\\config.txt";

  std::string settingsPath = ss.str();
  Settings::getInstance().loadSettings(settingsPath);

  if (!window.createOpenGLWindow(true)) {
		return 0;					
	}

  if (!window.start()) {
    window.end();
    window.killOpenGLWindow();		
    return 0;
  }

	while (!done) {
    if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))	{
			if (msg.message == WM_QUIT) {
				done = true;				
			}
			else {
				TranslateMessage(&msg);				
				DispatchMessage(&msg);		
			}
		}
    
    if (window.getActive()) {
		  if (window.getKey(VK_ESCAPE)) {
			  done = true;
		  }
			else {
        window.doMainLoop();
			}
		}

		if (window.getKey(VK_F11)) {
      window.keyUp(VK_F11);
      window.toggleFullscreen(); 
    }
  }

  Settings::getInstance().saveSettings(settingsPath);

  if (Settings::getInstance().getFullscreen()) {
    window.restoreBeforeFullscreen();
  }
  
  window.end();
	window.killOpenGLWindow();		
	return msg.wParam;				
}