#pragma once

// Lib files
#pragma comment (lib, "common/lib/opengl32.lib")
#pragma comment (lib, "common/lib/glu32.lib")
#pragma comment (lib, "common/lib/glew32.lib")
#pragma comment (lib, "common/lib/glaux.lib")

// SPH Simulation
#include "sph/sph.h"

// OpenGL
#include "common/include/gl/glew.h"
#include "common/include/gl/gl.h"
#include "common/include/gl/glu.h"
#include "common/include/gl/glaux.h"

// GLM
#include "common/include/glm/gtc/matrix_inverse.hpp"
#include "common/include/glm/gtc/matrix_transform.hpp"

// STL, Windows and other headers
#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <ctime>
#include <string>
#include <stdint.h>
#include <Windows.h>
#include <map>
#include <time.h>

// Macros
#include "macros.h"

// Constants
#include "consts.h"

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

// Program header files
#include "log.h"
#include "settings.h"

// GLsystem
#include "glsystem/WGL_ARB_Multisample.h"
#include "glsystem/render_options.h"
#include "glsystem/camera.h"
#include "glsystem/material.h"
#include "glsystem/light.h"
#include "glsystem/lights_manager.h"
#include "glsystem/cameras_manager.h"
#include "glsystem/shaders_manager.h"
#include "glsystem/opengl.h"

// Window system
#include "windowsystem/mouse.h"
#include "windowsystem/window.h"