const int NUM_LIGHTS = 3;

uniform vec4 lightPosition[NUM_LIGHTS];

varying vec3 _eyeVec;
varying vec3 _lightVec[NUM_LIGHTS];
varying vec3 _normalVec;


void main() {	
  vec4 vertexPosition = gl_ModelViewMatrix * gl_Vertex;
  _eyeVec = -vec3(vertexPosition);

  _normalVec = gl_NormalMatrix * gl_Normal;

  for (int i = 0; i < NUM_LIGHTS; i++) {
    _lightVec[i] = vec3(lightPosition[i] - vertexPosition);
  }

  gl_TexCoord[0] = gl_MultiTexCoord0;
  gl_Position = gl_ProjectionMatrix * vertexPosition; // ftransform()
  gl_FrontColor = gl_Color;
}
