#pragma once

using namespace clframework;

class Object {

  private:

    std::vector<Vector<3, float>> vertices;
    std::vector<Vector<2, int>> edges;
    std::vector<Vector<3, int>> triangles;

    void clear();
    void computeEdges();
    void fillTriangleWithParticles(Vector<3, float> v0, Vector<3, float> v1, Vector<3, float> v2, float distance, std::vector<Vector<3, float>>& particles);

  public:

    Object() {};
    ~Object();

    bool loadFromFile(std::string filePath);
    std::vector<Vector<3, float>> generateSurfaceParticles(float distance);

    void scale(float scaleFactor);
    void scale(Vector<3, float> scaleVector);
    void translate(Vector<3, float> translationVector);

    void drawEdges();

};