#pragma once

using namespace clframework;

class Scene {

  private:

    std::string name;

    Object aquarium;
    std::vector<Object> objects;

    char* fluidParticlesData;
    char* fluidParticlesDataOther;
    size_t fluidParticlesDataSize;
    size_t fluidParticlesDataOtherSize;
    size_t fluidParticlesCount;

    char* solidParticlesData;
    size_t solidParticlesDataSize;
    size_t solidParticlesCount;

  public:

    Scene();
    ~Scene();

    bool initScene(std::string name, Object &aquarium, std::vector<Object> &objects, int fluidParticlesCount, int solidParticlesCount);
    void freeScene();

    std::string getName() { return name; };
    Object* getAquarium() { return &aquarium; };
    std::vector<Object>& getObjects() { return objects; };

    void setFluidParticlesData(char* data, size_t size) { fluidParticlesData = data; fluidParticlesDataSize = size; };
    void setFluidParticlesDataOther(char* data, size_t size) { fluidParticlesDataOther = data; fluidParticlesDataOtherSize = size; };
    char* getFluidParticlesData() { return fluidParticlesData; };
    char* getFluidParticlesDataOther() { return fluidParticlesDataOther; };
    size_t getFluidParticlesDataSize() { return fluidParticlesDataSize; };
    size_t getFluidParticlesDataOtherSize() { return fluidParticlesDataOtherSize; };
    size_t getFluidParticlesCount() { return fluidParticlesCount; };

    void setSolidParticlesData(char* data, size_t size) { solidParticlesData = data; solidParticlesDataSize = size; };
    char* getSolidParticlesData() { return solidParticlesData; };
    size_t getSolidParticlesDataSize() { return solidParticlesDataSize; };
    size_t getSolidParticlesCount() { return solidParticlesCount; };

};